
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.Timer;

public class RepeaterFrame extends JFrame {

	private RepeaterPanel[] panels;
	private JPanel startPnl;	

	private Timer timer;

	public RepeaterFrame() {

		initPanels();

		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.getContentPane().setLayout(new BorderLayout());
		this.getContentPane().add(startPnl, BorderLayout.CENTER);
		this.getContentPane().add(panels[0], BorderLayout.WEST);
		this.getContentPane().add(panels[1], BorderLayout.NORTH);
		this.getContentPane().add(panels[2], BorderLayout.EAST);
		this.getContentPane().add(panels[3], BorderLayout.SOUTH);
		this.pack();
		this.setVisible(true);
	}

	private void initPanels() {
		startPnl = new JPanel();
		JButton startBtn = new JButton("Start");
		startBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				start();
			}
		});
		startPnl.add(startBtn);

		panels = new RepeaterPanel[]{
				new RepeaterPanel(Color.blue, new Dimension(50, 200), 0, this),
				new RepeaterPanel(Color.green, new Dimension(200, 50), 1, this),
				new RepeaterPanel(Color.red, new Dimension(50, 200), 2, this),
				new RepeaterPanel(Color.yellow, new Dimension(200, 50), 3, this)};
	}

	private void start() {
		RepeaterController.deleteSequence();
		RepeaterController.randomize();		
		startTimer();
	}
	
	protected void startTimer() {
		timer = new Timer(250, new RepeaterActionListener());		
		timer.start();
		setCursor(Cursor.WAIT_CURSOR);
	}

	public static void main(String args[]) {
		new RepeaterFrame();
	}
	
	private class RepeaterActionListener implements ActionListener {

		private int counter;
		private Vector sequence;	

		public RepeaterActionListener() {
			super();
			counter = 0;
		}

		public void actionPerformed(ActionEvent e) {

			if (sequence == null)
				sequence = RepeaterController.getSequence();

			if (panels[((Integer) sequence.elementAt(counter)).intValue()]
					.isBlinking())
				panels[((Integer) sequence.elementAt(counter++)).intValue()]
						.blink();
			else
				panels[((Integer) sequence.elementAt(counter)).intValue()]
						.blink();

			if (counter == sequence.size()) {
				timer.stop();
				counter = 0;
				sequence = null;
				setCursor(Cursor.DEFAULT_CURSOR);
			}
		}
	}
}
