
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.geom.Line2D;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.Timer;

public class RepeaterPanel extends JPanel {

	private Color color;
	private Color orgColor;

	private int result;

	private boolean isBlinking;

	private Timer timer;

	private JButton button;

	private RepeaterFrame parent;

	private int id;

	public RepeaterPanel(Color color, Dimension dimension, int id,
			RepeaterFrame parent) {
		super();

		this.id = id;
		this.color = color;
		this.orgColor = this.getBackground();
		this.parent = parent;
		this.setPreferredSize(dimension);

		button = new JButton();
		button.setBackground(color);
		button.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {

				button_mouseClicked(e);
			}
		});
		button.setPreferredSize(new Dimension(
				this.getPreferredSize().width - 25,
				this.getPreferredSize().height - 25));

		this.add(button);

		isBlinking = false;
	}

	protected int getPanelId() {
		return id;
	}

	private void button_mouseClicked(MouseEvent e) {
		if (parent.getCursor().getType() == Cursor.DEFAULT_CURSOR) {
			result = RepeaterController.check(this.id);

			if (result <= 1) {
				System.out.println("Richtig");
				parent.setCursor(Cursor.WAIT_CURSOR);
				timer = new Timer(250, new ActionListener() {
					int count = 0;
					public void actionPerformed(ActionEvent e) {
						if (count <= 1) {
							blink();
							count++;
						} else {
							timer.stop();
							parent.setCursor(Cursor.DEFAULT_CURSOR);
							if (result == 0) {
								System.out
										.println("Sequenz erfolgreich wiederholt");
								parent.startTimer();
							}
						}
					}
				});
				timer.start();
			} else {
				System.out.println("Fehler");
			}
		}
	}
	protected void blink() {
		if (isBlinking) {
			this.setBackground(orgColor);
		} else {
			this.setBackground(color);
		}
		isBlinking = !isBlinking;
	}

	protected boolean isBlinking() {
		return isBlinking;
	}
}
